@echo off
cd /d %~dps0
del /F /Q compile_models.log

setlocal

if NOT EXIST ..\..\ufomodel.exe (
	@echo Missing ufomodel
	@echo compile ufomodel.cbp first
	pause
	exit /b 1
)

cd ..\..\base
for /f "tokens=*" %%A in ('cd') do (
	cd /d %~dps0
rem	for /f "tokens=*" %%a in ('dir ..\..\base\models\* /B /S ^| findstr /I /R /C:".md2"$ /C:".md3"$ /C:".obj"$ /C:".dpm"$ ^|findstr /I /V /C:".svn"') do (
	for /f "tokens=*" %%a in ('dir ..\..\base\models\* /B /S ^| findstr /I /R /C:".md2"$ /C:".md3"$ /C:".dpm"$ ^|findstr /I /V /C:".svn"') do (
		@echo %%a
		del /F /Q "%%~dpna.mdx"
		for /f "tokens=1-3 delims=," %%b in ('findstr /I /R /C:"models/" /C:"))))"$ ..\..\build\models.mk') do (
rem			@echo [%%b] [%%c] [%%d]
			if not "%%c"=="" (
				@echo "%%a" "%%A" %%d %%c
				call :config "%%a" "%%A" %%d %%c || exit /b 1
			)
			if "%%c"=="" (
				@echo "%%a" "%%A" "%%b"
				call :config "%%a" "%%A" "%%b" || exit /b 1
			)
		)
	)
)

endlocal
@echo ok
exit /b 0


:config
	@echo %~1 %3 %4
	set sub_path=%4
	set sub_path=%sub_path:/=\%
	set sub_path=%sub_path:(=%
	set sub_path=%sub_path:)=%
	
	set smoothness=%~3
	set smoothness=%smoothness: =%
	set smoothness=%smoothness:(=%
	set smoothness=%smoothness:)=%
	@echo [%sub_path%]
	@echo [%smoothness%]

	set model_path=%~1
	call set model_path=%%model_path:%~2=%%
	set model_path=%model_path:\=/%
	@echo [%model_path%]

	@echo %~1 | findstr /I /C:"%sub_path%" && (
		call :make %smoothness% %model_path% || exit /b 1
		exit /b 0
	)
	if "%4"=="" (
		if Not exist "%~dpn1.mdx" (
			call :make %smoothness% %model_path% || exit /b 1
		)
	)
	exit /b 0
Goto :EOF

:make
	@echo ufomodel.exe -mdx -overwrite -v -s %1 -f %2 >>compile_models.log
	cd ..\..
	ufomodel.exe -mdx -overwrite -v -s %1 -f %2 || (
		@echo error
		cd /d %~dps0
		type ..\..\stdout.txt >>compile_models.log
		type ..\..\stderr.txt >>compile_models.log
		cmd /c compile_models.log
		pause
		exit /b 1
	)
	cd /d %~dps0
	exit /b 0
Goto :EOF